from __future__ import annotations
import datetime
import pybind11_stubgen.typing_ext
import typing
__all__ = ['CartesianPose', 'CartesianVelocities', 'ControllerMode', 'Duration', 'Errors', 'Frame', 'Gripper', 'GripperState', 'JointPositions', 'JointVelocities', 'MAX_TORQUE_RATE', 'Model', 'RealtimeConfig', 'Robot', 'RobotMode', 'RobotState', 'Torques', 'VacuumGripper', 'VacuumGripperDeviceStatus', 'VacuumGripperProductionSetupProfile', 'VacuumGripperState', 'has_realtime_kernel', 'is_homogeneous_transformation', 'is_valid_elbow', 'limit_rate', 'motion_finished', 'set_current_thread_to_highest_scheduler_priority']
class CartesianPose:
    O_T_EE: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]
    elbow: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(2)]
    motion_finished: bool
    @typing.overload
    def __init__(self, cartesian_pose: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]) -> None:
        ...
    @typing.overload
    def __init__(self, cartesian_pose: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)], elbow: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(2)]) -> None:
        ...
class CartesianVelocities:
    O_dP_EE: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]
    elbow: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(2)]
    motion_finished: bool
    @typing.overload
    def __init__(self, cartesian_velocities: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]) -> None:
        ...
    @typing.overload
    def __init__(self, cartesian_velocities: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)], elbow: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(2)]) -> None:
        ...
class ControllerMode:
    """
    Members:
    
      kCartesianImpedance
    
      kJointImpedance
    """
    __members__: typing.ClassVar[dict[str, ControllerMode]]  # value = {'kCartesianImpedance': <ControllerMode.kCartesianImpedance: 1>, 'kJointImpedance': <ControllerMode.kJointImpedance: 0>}
    kCartesianImpedance: typing.ClassVar[ControllerMode]  # value = <ControllerMode.kCartesianImpedance: 1>
    kJointImpedance: typing.ClassVar[ControllerMode]  # value = <ControllerMode.kJointImpedance: 0>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class Duration:
    @typing.overload
    def __init__(self) -> None:
        ...
    @typing.overload
    def __init__(self, milliseconds: int) -> None:
        ...
    @typing.overload
    def __init__(self, duration: datetime.timedelta) -> None:
        ...
    def to_msec(self) -> int:
        ...
    def to_sec(self) -> float:
        ...
class Errors:
    def __bool__(self) -> bool:
        ...
    def __init__(self) -> None:
        ...
    def __repr__(self) -> str:
        ...
    @property
    def cartesian_motion_generator_acceleration_discontinuity(self) -> bool:
        ...
    @property
    def cartesian_motion_generator_elbow_limit_violation(self) -> bool:
        ...
    @property
    def cartesian_motion_generator_elbow_sign_inconsistent(self) -> bool:
        ...
    @property
    def cartesian_motion_generator_joint_acceleration_discontinuity(self) -> bool:
        ...
    @property
    def cartesian_motion_generator_joint_position_limits_violation(self) -> bool:
        ...
    @property
    def cartesian_motion_generator_joint_velocity_discontinuity(self) -> bool:
        ...
    @property
    def cartesian_motion_generator_joint_velocity_limits_violation(self) -> bool:
        ...
    @property
    def cartesian_motion_generator_start_elbow_invalid(self) -> bool:
        ...
    @property
    def cartesian_motion_generator_velocity_discontinuity(self) -> bool:
        ...
    @property
    def cartesian_motion_generator_velocity_limits_violation(self) -> bool:
        ...
    @property
    def cartesian_position_limits_violation(self) -> bool:
        ...
    @property
    def cartesian_position_motion_generator_invalid_frame(self) -> bool:
        ...
    @property
    def cartesian_position_motion_generator_start_pose_invalid(self) -> bool:
        ...
    @property
    def cartesian_reflex(self) -> bool:
        ...
    @property
    def cartesian_velocity_profile_safety_violation(self) -> bool:
        ...
    @property
    def cartesian_velocity_violation(self) -> bool:
        ...
    @property
    def communication_constraints_violation(self) -> bool:
        ...
    @property
    def controller_torque_discontinuity(self) -> bool:
        ...
    @property
    def force_control_safety_violation(self) -> bool:
        ...
    @property
    def force_controller_desired_force_tolerance_violation(self) -> bool:
        ...
    @property
    def instability_detected(self) -> bool:
        ...
    @property
    def joint_motion_generator_acceleration_discontinuity(self) -> bool:
        ...
    @property
    def joint_motion_generator_position_limits_violation(self) -> bool:
        ...
    @property
    def joint_motion_generator_velocity_discontinuity(self) -> bool:
        ...
    @property
    def joint_motion_generator_velocity_limits_violation(self) -> bool:
        ...
    @property
    def joint_move_in_wrong_direction(self) -> bool:
        ...
    @property
    def joint_p2p_insufficient_torque_for_planning(self) -> bool:
        ...
    @property
    def joint_position_limits_violation(self) -> bool:
        ...
    @property
    def joint_position_motion_generator_start_pose_invalid(self) -> bool:
        ...
    @property
    def joint_reflex(self) -> bool:
        ...
    @property
    def joint_velocity_violation(self) -> bool:
        ...
    @property
    def max_goal_pose_deviation_violation(self) -> bool:
        ...
    @property
    def max_path_pose_deviation_violation(self) -> bool:
        ...
    @property
    def power_limit_violation(self) -> bool:
        ...
    @property
    def self_collision_avoidance_violation(self) -> bool:
        ...
    @property
    def start_elbow_sign_inconsistent(self) -> bool:
        ...
    @property
    def tau_j_range_violation(self) -> bool:
        ...
class Frame:
    """
    Members:
    
      kJoint1
    
      kJoint2
    
      kJoint3
    
      kJoint4
    
      kJoint5
    
      kJoint6
    
      kJoint7
    
      kFlange
    
      kEndEffector
    
      kStiffness
    """
    __members__: typing.ClassVar[dict[str, Frame]]  # value = {'kJoint1': <Frame.kJoint1: 0>, 'kJoint2': <Frame.kJoint2: 1>, 'kJoint3': <Frame.kJoint3: 2>, 'kJoint4': <Frame.kJoint4: 3>, 'kJoint5': <Frame.kJoint5: 4>, 'kJoint6': <Frame.kJoint6: 5>, 'kJoint7': <Frame.kJoint7: 6>, 'kFlange': <Frame.kFlange: 7>, 'kEndEffector': <Frame.kEndEffector: 8>, 'kStiffness': <Frame.kStiffness: 9>}
    kEndEffector: typing.ClassVar[Frame]  # value = <Frame.kEndEffector: 8>
    kFlange: typing.ClassVar[Frame]  # value = <Frame.kFlange: 7>
    kJoint1: typing.ClassVar[Frame]  # value = <Frame.kJoint1: 0>
    kJoint2: typing.ClassVar[Frame]  # value = <Frame.kJoint2: 1>
    kJoint3: typing.ClassVar[Frame]  # value = <Frame.kJoint3: 2>
    kJoint4: typing.ClassVar[Frame]  # value = <Frame.kJoint4: 3>
    kJoint5: typing.ClassVar[Frame]  # value = <Frame.kJoint5: 4>
    kJoint6: typing.ClassVar[Frame]  # value = <Frame.kJoint6: 5>
    kJoint7: typing.ClassVar[Frame]  # value = <Frame.kJoint7: 6>
    kStiffness: typing.ClassVar[Frame]  # value = <Frame.kStiffness: 9>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class Gripper:
    def __init__(self, franka_address: str) -> None:
        ...
    def grasp(self, width: float, speed: float, force: float, epsilon_inner: float = 0.005, epsilon_outer: float = 0.005) -> bool:
        ...
    def homing(self) -> bool:
        ...
    def move(self, width: float, speed: float) -> bool:
        ...
    def read_once(self) -> GripperState:
        ...
    def server_version(self) -> int:
        ...
    def stop(self) -> bool:
        ...
class GripperState:
    @property
    def is_grasped(self) -> bool:
        ...
    @property
    def max_width(self) -> float:
        ...
    @property
    def temperature(self) -> int:
        ...
    @property
    def time(self) -> Duration:
        ...
    @property
    def width(self) -> float:
        ...
class JointPositions:
    motion_finished: bool
    q: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]
    def __init__(self, joint_positions: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]) -> None:
        ...
class JointVelocities:
    dq: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]
    motion_finished: bool
    def __init__(self, joint_velocities: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]) -> None:
        ...
class Model:
    @typing.overload
    def body_jacobian(self, frame: Frame, robot_state: RobotState) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(42)]:
        ...
    @typing.overload
    def body_jacobian(self, frame: Frame, q: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], F_T_EE: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)], EE_T_K: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(42)]:
        ...
    @typing.overload
    def coriolis(self, robot_state: RobotState) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @typing.overload
    def coriolis(self, q: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], dq: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], I_total: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(9)], m_total: float, F_x_Ctotal: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(3)]) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @typing.overload
    def gravity(self, q: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], m_total: float, F_x_Ctotal: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(3)], gravity_earth: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(3)] = [0.0, 0.0, -9.81]) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @typing.overload
    def gravity(self, robot_state: RobotState, gravity_earth: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(3)] = [0.0, 0.0, -9.81]) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @typing.overload
    def mass(self, robot_state: RobotState) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(49)]:
        ...
    @typing.overload
    def mass(self, q: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], I_total: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(9)], m_total: float, F_x_Ctotal: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(3)]) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(49)]:
        ...
    @typing.overload
    def pose(self, frame: Frame, robot_state: RobotState) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]:
        ...
    @typing.overload
    def pose(self, frame: Frame, q: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], F_T_EE: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)], EE_T_K: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]:
        ...
    @typing.overload
    def zero_jacobian(self, frame: Frame, robot_state: RobotState) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(42)]:
        ...
    @typing.overload
    def zero_jacobian(self, frame: Frame, q: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], F_T_EE: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)], EE_T_K: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(42)]:
        ...
class RealtimeConfig:
    """
    Members:
    
      kEnforce
    
      kIgnore
    """
    __members__: typing.ClassVar[dict[str, RealtimeConfig]]  # value = {'kEnforce': <RealtimeConfig.kEnforce: 0>, 'kIgnore': <RealtimeConfig.kIgnore: 1>}
    kEnforce: typing.ClassVar[RealtimeConfig]  # value = <RealtimeConfig.kEnforce: 0>
    kIgnore: typing.ClassVar[RealtimeConfig]  # value = <RealtimeConfig.kIgnore: 1>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class Robot:
    def __init__(self, franka_address: str, realtime_config: RealtimeConfig = RealtimeConfig.kIgnore, log_size: int = 50) -> None:
        ...
    def automatic_error_recovery(self) -> None:
        ...
    def control(self, control_callback: typing.Callable[[RobotState, Duration], Torques], limit_rate: bool = True, cutoff_frequency: float = 100.0) -> None:
        ...
    def load_model(self) -> Model:
        ...
    def read(self, arg0: typing.Callable[[RobotState], bool]) -> None:
        ...
    def read_once(self) -> RobotState:
        ...
    def server_version(self) -> int:
        ...
    def set_cartesian_impedance(self, K_x: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]) -> None:
        ...
    @typing.overload
    def set_collision_behavior(self, lower_torque_thresholds_acceleration: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], upper_torque_thresholds_acceleration: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], lower_torque_thresholds_nominal: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], upper_torque_thresholds_nominal: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], lower_force_thresholds_acceleration: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)], upper_force_thresholds_acceleration: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)], lower_force_thresholds_nominal: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)], upper_force_thresholds_nominal: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]) -> None:
        ...
    @typing.overload
    def set_collision_behavior(self, lower_torque_thresholds: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], upper_torque_thresholds: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], lower_force_thresholds: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)], upper_force_thresholds: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]) -> None:
        ...
    def set_ee(self, NE_T_EE: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]) -> None:
        ...
    def set_guiding_mode(self, guiding_mode: typing.Annotated[list[bool], pybind11_stubgen.typing_ext.FixedSize(6)], elbow: bool) -> None:
        ...
    def set_joint_impedance(self, K_theta: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]) -> None:
        ...
    def set_k(self, EE_T_K: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]) -> None:
        ...
    def set_load(self, load_mass: float, F_x_Cload: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(3)], load_inertia: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(9)]) -> None:
        ...
    def stop(self) -> None:
        ...
class RobotMode:
    """
    Members:
    
      kOther
    
      kIdle
    
      kMove
    
      kGuiding
    
      kReflex
    
      kUserStopped
    
      kAutomaticErrorRecovery
    """
    __members__: typing.ClassVar[dict[str, RobotMode]]  # value = {'kOther': <RobotMode.kOther: 0>, 'kIdle': <RobotMode.kIdle: 1>, 'kMove': <RobotMode.kMove: 2>, 'kGuiding': <RobotMode.kGuiding: 3>, 'kReflex': <RobotMode.kReflex: 4>, 'kUserStopped': <RobotMode.kUserStopped: 5>, 'kAutomaticErrorRecovery': <RobotMode.kAutomaticErrorRecovery: 6>}
    kAutomaticErrorRecovery: typing.ClassVar[RobotMode]  # value = <RobotMode.kAutomaticErrorRecovery: 6>
    kGuiding: typing.ClassVar[RobotMode]  # value = <RobotMode.kGuiding: 3>
    kIdle: typing.ClassVar[RobotMode]  # value = <RobotMode.kIdle: 1>
    kMove: typing.ClassVar[RobotMode]  # value = <RobotMode.kMove: 2>
    kOther: typing.ClassVar[RobotMode]  # value = <RobotMode.kOther: 0>
    kReflex: typing.ClassVar[RobotMode]  # value = <RobotMode.kReflex: 4>
    kUserStopped: typing.ClassVar[RobotMode]  # value = <RobotMode.kUserStopped: 5>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class RobotState:
    def __repr__(self) -> str:
        ...
    @property
    def EE_T_K(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]:
        ...
    @property
    def F_T_EE(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]:
        ...
    @property
    def F_x_Cee(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(3)]:
        ...
    @property
    def F_x_Cload(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(3)]:
        ...
    @property
    def F_x_Ctotal(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(3)]:
        ...
    @property
    def I_ee(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(9)]:
        ...
    @property
    def I_load(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(9)]:
        ...
    @property
    def I_total(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(9)]:
        ...
    @property
    def K_F_ext_hat_K(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]:
        ...
    @property
    def O_F_ext_hat_K(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]:
        ...
    @property
    def O_T_EE(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]:
        ...
    @property
    def O_T_EE_c(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]:
        ...
    @property
    def O_T_EE_d(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]:
        ...
    @property
    def O_dP_EE_c(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]:
        ...
    @property
    def O_dP_EE_d(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]:
        ...
    @property
    def O_ddP_EE_c(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]:
        ...
    @property
    def cartesian_collision(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]:
        ...
    @property
    def cartesian_contact(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(6)]:
        ...
    @property
    def control_command_success_rate(self) -> float:
        ...
    @property
    def current_errors(self) -> Errors:
        ...
    @property
    def ddelbow_c(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(2)]:
        ...
    @property
    def ddq_d(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def delbow_c(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(2)]:
        ...
    @property
    def dq(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def dq_d(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def dtau_J(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def dtheta(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def elbow(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(2)]:
        ...
    @property
    def elbow_c(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(2)]:
        ...
    @property
    def elbow_d(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(2)]:
        ...
    @property
    def joint_collision(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def joint_contact(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def last_motion_errors(self) -> Errors:
        ...
    @property
    def m_ee(self) -> float:
        ...
    @property
    def m_load(self) -> float:
        ...
    @property
    def m_total(self) -> float:
        ...
    @property
    def q(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def q_d(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def robot_mode(self) -> RobotMode:
        ...
    @property
    def tau_J(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def tau_J_d(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def tau_ext_hat_filtered(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def theta(self) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
        ...
    @property
    def time(self) -> Duration:
        ...
class Torques:
    motion_finished: bool
    tau_J: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]
    def __init__(self, torques: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]) -> None:
        ...
class VacuumGripper:
    def __init__(self, franka_address: str) -> None:
        ...
    def drop_off(self, timeout: datetime.timedelta) -> bool:
        ...
    def read_once(self) -> VacuumGripperState:
        ...
    def server_version(self) -> int:
        ...
    def stop(self) -> bool:
        ...
    def vacuum(self, vacuum: int, timeout: datetime.timedelta, profile: VacuumGripperProductionSetupProfile = VacuumGripperProductionSetupProfile.kP0) -> bool:
        ...
class VacuumGripperDeviceStatus:
    """
    Members:
    
      kGreen
    
      kYellow
    
      kOrange
    
      kRed
    """
    __members__: typing.ClassVar[dict[str, VacuumGripperDeviceStatus]]  # value = {'kGreen': <VacuumGripperDeviceStatus.kGreen: 0>, 'kYellow': <VacuumGripperDeviceStatus.kYellow: 1>, 'kOrange': <VacuumGripperDeviceStatus.kOrange: 2>, 'kRed': <VacuumGripperDeviceStatus.kRed: 3>}
    kGreen: typing.ClassVar[VacuumGripperDeviceStatus]  # value = <VacuumGripperDeviceStatus.kGreen: 0>
    kOrange: typing.ClassVar[VacuumGripperDeviceStatus]  # value = <VacuumGripperDeviceStatus.kOrange: 2>
    kRed: typing.ClassVar[VacuumGripperDeviceStatus]  # value = <VacuumGripperDeviceStatus.kRed: 3>
    kYellow: typing.ClassVar[VacuumGripperDeviceStatus]  # value = <VacuumGripperDeviceStatus.kYellow: 1>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class VacuumGripperProductionSetupProfile:
    """
    Members:
    
      kP0
    
      kP1
    
      kP2
    
      kP3
    """
    __members__: typing.ClassVar[dict[str, VacuumGripperProductionSetupProfile]]  # value = {'kP0': <VacuumGripperProductionSetupProfile.kP0: 0>, 'kP1': <VacuumGripperProductionSetupProfile.kP1: 1>, 'kP2': <VacuumGripperProductionSetupProfile.kP2: 2>, 'kP3': <VacuumGripperProductionSetupProfile.kP3: 3>}
    kP0: typing.ClassVar[VacuumGripperProductionSetupProfile]  # value = <VacuumGripperProductionSetupProfile.kP0: 0>
    kP1: typing.ClassVar[VacuumGripperProductionSetupProfile]  # value = <VacuumGripperProductionSetupProfile.kP1: 1>
    kP2: typing.ClassVar[VacuumGripperProductionSetupProfile]  # value = <VacuumGripperProductionSetupProfile.kP2: 2>
    kP3: typing.ClassVar[VacuumGripperProductionSetupProfile]  # value = <VacuumGripperProductionSetupProfile.kP3: 3>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: int) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: int) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class VacuumGripperState:
    @property
    def actual_power(self) -> int:
        ...
    @property
    def device_status(self) -> VacuumGripperDeviceStatus:
        ...
    @property
    def in_control_range(self) -> bool:
        ...
    @property
    def part_detached(self) -> bool:
        ...
    @property
    def part_present(self) -> bool:
        ...
    @property
    def time(self) -> Duration:
        ...
    @property
    def vacuum(self) -> int:
        ...
def has_realtime_kernel() -> bool:
    ...
def is_homogeneous_transformation(transform: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(16)]) -> bool:
    ...
def is_valid_elbow(elbow: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(2)]) -> bool:
    ...
def limit_rate(arg0: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], arg1: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)], arg2: typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]) -> typing.Annotated[list[float], pybind11_stubgen.typing_ext.FixedSize(7)]:
    ...
@typing.overload
def motion_finished(command: Torques) -> Torques:
    ...
@typing.overload
def motion_finished(command: JointPositions) -> JointPositions:
    ...
@typing.overload
def motion_finished(command: JointVelocities) -> JointVelocities:
    ...
@typing.overload
def motion_finished(command: CartesianPose) -> CartesianPose:
    ...
@typing.overload
def motion_finished(command: CartesianVelocities) -> CartesianVelocities:
    ...
def set_current_thread_to_highest_scheduler_priority(error_message: str) -> bool:
    ...
MAX_TORQUE_RATE: list = [999.999, 999.999, 999.999, 999.999, 999.999, 999.999, 999.999]
